/*------------------------------------------------------------------------------
#
#	TV-Man.Errors.h
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#
#
#	This is the file that is common to all Errors stuff. See the following disclaimer
#
#	In order to have an evironment which predictable events happen several definitions
#	must be established. The most critical is in the file architecture. Each functional
#	block will have its own source and header file. The main project file,  in this
#	case TV-Man, will have its header file included with all other files. This will
#	allow for global constants. The utility source file shall contain functions that
#	are general purpose in nature and that can be used by all other functions. These
#	are intended not to be application or major block specific. In order for this to be 
#	accomodated all functions in the utility source file must use only the information
#	that is passed to them or information that can be gleaned from the system via
#	toolbox calls. There will be no header file associated with the utility file as this
#	will destroy the intent of the utilities.
#
#	There are several files which contain information which is global in nature .These
#	file are included in the main project header file. They are: x.Errors.h, x.Ext.h,
#	x.Protos.h, x.Menus.h. The reason for containing them in seperate files is one of
#	convienience and accesability. 
#
#
#	Revision Log:
#	
#		4-26-91		RGK		Creation
#
#
------------------------------------------------------------------------------*/




/*-----------------------------------------------------------------------------*/
/*	The following are the resource numbers for the error dialogs */

#define	eMajor		(rErrors * 10)		/* Major error message alert		*/
#define eMinor		(rErrors * 10) + 1	/* Minor errors	message alert		*/




/*-----------------------------------------------------------------------------*/
/*	The following is the list of possible Major error messages */

#define	eMajorRoms			1		/* Wrong ROMs					*/
#define	eMajorHeap			2		/* Heap to small				*/
#define	eMajorRam			3		/* No Ram Left					*/
#define	eMajorRsrc			4		/* Couldn't open resource		*/
#define	eMajorWindow		5		/* couldn't get window pointer	*/
#define	eMajorMenu			6		/* couldn't get Menubar pointer */
#define	eMajorDialog		7		/* couldn't open a dialog box	*/
#define eMajorNoDispose		8		/* can't scrap sound channel	*/	



/*-----------------------------------------------------------------------------*/
/*	The following is the list of possible Minor error messages */

#define eMinorNotYet		1		/* Not avaliable yet message	*/
#define eMinorRsrc			2		/* error getting resource		*/
#define eMinorDialog		3		/* Error opening Dialog 		*/
#define eMinorMenu			4		/* No Menu Error				*/
#define eMinorSound			5		/* No sound channel error		*/
#define eMinorNoSnd			6		/* That Sound is not available	*/
#define eMinorNoDispose		7		/* can't scrap sound channel	*/
#define eMinorSPlay			8		/* Homey don't play that		*/


/*----------------------------------------------------------------------------*/
/*	The following line will effectivly eliminate the following typedefs from the 
	this header file during the Rez process because Rez cannot handle typedefs.
	All Resource files will define "__Rezing__" when processing, all C sources
	will not	*/
	
#ifndef __Rezing__

/*----------------------------------------------------------------------------*/
/*	Nothing Yet	*/

#endif __Rezing__