#-------------------------------------------------------------------------------------
#
#	TV-Man.make	-	Make Source
#
#	Copyright  Apple Computer, Inc. 1989-1990
#	All rights reserved.
#
#
#
#	Revision Log:
#	
#		4-26-91		RGK		Creation
#
#
#---------------------------------------------------------------------------------------



#---------------------------------------------------------------------------------------
#	Build Variables

OBJ				=	:Object:
SRC				=	:Source:
RES				=	:Resources:
INC				=	:Includes:
REZ				=	:RezMan:

SymOptions		=	-sym full 





#---------------------------------------------------------------------------------------
#	this is a list of the options used in the various processes during the build

Rezopt			=	-append							
					-i "{INC}"						
					-i "{REZ}"						
					-rd	
				
COpt	 		= 	-r								
					-i "{INC}"						
					{SymOptions}
				
				
LibOpt			=	{SymOptions}
				
				
LinkOpt			=	{SymOptions}


Setopt			=	-d . 							
					-t "APPL"						
					-c "TVMN"						
					-a vB 





#---------------------------------------------------------------------------------------
#	Now we will start the dependency rules for the program. The first will be the 
#	rules for the resource.

"{PROJECT}"											
						"{PROJECT}.make"			
						"{RES}{PROJECT}.r"			
						"{INC}{PROJECT}.h"
		Rez -o "{PROJECT}" "{RES}{PROJECT}.r" {RezOpt}




"{PROJECT}"											
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Menus.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Menus.h"
		Rez -o "{PROJECT}" "{RES}{PROJECT}.Menus.r" {RezOpt}





"{PROJECT}"											
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Errors.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Errors.h"
		Rez -o "{PROJECT}" "{RES}{PROJECT}.Errors.r" {RezOpt}




"{PROJECT}"											
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Video.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Video.h"
		Rez -o "{PROJECT}" "{RES}{PROJECT}.Video.r" {RezOpt}




"{PROJECT}"											
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Sound.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Sound.h"
		Rez -o "{PROJECT}" "{RES}{PROJECT}.Sound.r" {RezOpt}




#	As a seperate issue from TV-Man the following REZ will add to the library to
#	be used by other programs.


"{OBJ}BeepMgr.lib"									
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Errors.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Errors.h"
		Rez -o "{OBJ}BeepMgr.lib" "{RES}{PROJECT}.Errors.r" {RezOpt}


"{OBJ}BeepMgr.lib"									
						"{PROJECT}.make"			
						"{RES}{PROJECT}.Sound.r"	
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Sound.h"
		Rez -o "{OBJ}BeepMgr.lib" "{RES}{PROJECT}.Sound.r" {RezOpt}





#---------------------------------------------------------------------------------------
#	Now comes the list of all the seperate C to object dependencies

"{OBJ}{PROJECT}.c.o"			 					
						"{PROJECT}.make"			
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Ext.h"		
						"{INC}{PROJECT}.Menus.h"	
						"{INC}{PROJECT}.Protos.h"	
						"{INC}{PROJECT}.Errors.h"	
						"{SRC}{PROJECT}.c"
		C -o "{OBJ}{PROJECT}.c.o" "{SRC}{PROJECT}.c" {COpt}



"{OBJ}{PROJECT}.Init.c.o"							
						"{PROJECT}.make"			
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Ext.h"		
						"{INC}{PROJECT}.Menus.h"	
						"{INC}{PROJECT}.Protos.h"	
						"{INC}{PROJECT}.Errors.h"	
						"{SRC}{PROJECT}.Init.c"
		C -o "{OBJ}{PROJECT}.Init.c.o" "{SRC}{PROJECT}.Init.c" {COpt}




"{OBJ}{PROJECT}.Utility.c.o"						
						"{PROJECT}.make"			
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Ext.h"		
						"{INC}{PROJECT}.Menus.h"	
						"{INC}{PROJECT}.Protos.h"	
						"{INC}{PROJECT}.Errors.h"	
						"{SRC}{PROJECT}.Utility.c"
		C -o "{OBJ}{PROJECT}.Utility.c.o" "{SRC}{PROJECT}.Utility.c" {COpt}




"{OBJ}{PROJECT}.Video.c.o"							
						"{PROJECT}.make"			
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Ext.h"		
						"{INC}{PROJECT}.Menus.h"	
						"{INC}{PROJECT}.Protos.h"	
						"{INC}{PROJECT}.Errors.h"	
						"{INC}{PROJECT}.Video.h"	
						"{SRC}{PROJECT}.Video.c"
		C -o "{OBJ}{PROJECT}.Video.c.o" "{SRC}{PROJECT}.Video.c" {COpt}




"{OBJ}{PROJECT}.Sound.c.o"							
						"{PROJECT}.make"			
						"{INC}{PROJECT}.h"			
						"{INC}{PROJECT}.Ext.h"		
						"{INC}{PROJECT}.Menus.h"	
						"{INC}{PROJECT}.Protos.h"	
						"{INC}{PROJECT}.Errors.h"	
						"{INC}{PROJECT}.Sound.h"	
						"{SRC}{PROJECT}.Sound.c"
		C -o "{OBJ}{PROJECT}.Sound.c.o" "{SRC}{PROJECT}.Sound.c" {COpt}






#---------------------------------------------------------------------------------------
#	This is a list of all the necessary Object files. This list also controls the order
#	of the compile and link.

CLibObjs			=	"{Libraries}Runtime.o"		
						"{Libraries}Interface.o"

			
ProjectObjs			=	"{OBJ}{PROJECT}.c.o"		
						"{OBJ}{PROJECT}.Init.c.o"	
						"{OBJ}{PROJECT}.Utility.c.o"
						"{OBJ}{PROJECT}.Video.c.o"	
						"{OBJ}{PROJECT}.Sound.c.o"



#	As a seperate issue from TV-Man the following groups will become libraries to
#	be used by other programs.

BeepMgrObjs			=	"{OBJ}{PROJECT}.Utility.c.o"
						"{OBJ}{PROJECT}.Sound.c.o"







#---------------------------------------------------------------------------------------
#	Now for the library file dependencies.

"{OBJ}{PROJECT}.lib"				 				
						"{PROJECT}.make"			
						{ProjectObjs}
		Lib -o "{OBJ}{PROJECT}.lib" {ProjectObjs} {CLibObjs} {LibOpt}




#	this is a library generated for use else where.

"{OBJ}BeepMgr.lib"					 				
						"{PROJECT}.make"			
						{BeepMgrObjs}
		Lib -o "{OBJ}BeepMgr.lib" {BeepMgrObjs} {LibOpt}





#---------------------------------------------------------------------------------------
#	Now for the Project dependencies. Relink if any of the objects have changed

"{PROJECT}"							 				
						{CLibObjs}					
						"{OBJ}{PROJECT}.lib"		
						"{OBJ}BeepMgr.lib"			
						"{PROJECT}.make"
		Link -o "{PROJECT}" "{OBJ}{PROJECT}.lib" {LinkOpt}		
		SetFile "{PROJECT}" {SetOpt}


