/*
 *	File:		UVUAssist.h
 *
 *	Contains:	C++ header file for the V.U. Assistance Hook for MacApp applications, which is
 *	implemented in Object Pascal.
 *
 *	Written by:	Jim Schneider and Jeroen Schalk
 *
 *	Copyright:	 1991 by Apple Computer, Inc., all rights reserved.
 *
 *  Version: 1.0d10
 *
 *	Change History:
 *
 *		  8/21/91	JAS			change version
 *			8/19/91	JAS			change case of of GridItemSupport to gridItemSupport
 *		  8/15/91	JAS		  change ifndef symbol to __UVUASSIST__
 *		  8/15/91	JAS		  change case of boolean, add GridItemSupport arg to IVUAssist
 *		  8/15/91	Jim		  add fGridItemSupport as new data member to TVUAssist
 *		  8/13/91	Jim		  stripped down to essentials, make TVUAssist subclass of TEvtHandler 
 *		  1/18/91	Jim		  modified Jeroen Schalk's header posted on Virtual User Discussion 
 *
 */


#ifndef __UVUASSIST__
#define __UVUASSIST__

#ifndef  __UMacApp__
#include "UMacApp.h"
#endif

/* ================================================================== */
/* Class definitions */
	
class TVUAssist : public TEvtHandler {
	
	private:
  	
		short 	fMoleRefNum;
		
		Boolean	fGridItemSupport; 
	
		public:
  	
		virtual pascal void IVUAssist(Boolean gridItemSupport);
		
		virtual pascal void OpenMoleDriver(void);
		
		virtual pascal void SuspendMole(void);
		
		virtual pascal void ResumeMole(void);
		
		virtual pascal void SetDebuggerHook(ProcPtr NewHook);
	
		virtual pascal short MoleAssist(short Select, Ptr Input, Ptr Output, short *OutputSize, 
			short IntResult);
		
	};


/* ================================================================== */
/* Variable definitions */

TVUAssist *gVUAssist;

#ifdef qDebug
	
	Boolean 	gVUDebug;

#endif


#endif // of #ifndef __UVUASSIST__
